#ifndef IntfUtilsH
#define IntfUtilsH

#include <vcl.h>
#pragma hdrstop
#include "OTAUtils.h"

//pour dfinir le type de wizard  crer
enum TTypeWizard {twNone, twFiche, twProjet, twAide, twAddIn};
//pour les erreurs de saisie
enum TTypeErrorWizard {teNone, teError, teWarning, teHint};

struct TTypeError
{
  AnsiString ErrorMessage;
  TTypeErrorWizard ErrorType;
  TWinControl* ErrorControl;
  __fastcall TTypeError() {ErrorControl = NULL;}  
};

const int PAGECHOIXEXPERT   = 0;
const int PAGECLASSEEXPERT  = 1;
const int PAGEREPOSITORY    = 2;
const int PAGERECAPITULATIF = 3;
const int NORMALHEIGHT      = 390;
const int ERRORHEIGHT       = 520;
//---------------------------------------------------------------------------
class EUnknowWizardType : public Exception
{
  public :
  __fastcall EUnknowWizardType(AnsiString Text) : Exception(Text){} 
};
//---------------------------------------------------------------------------
class TInfoExpertCollector
{
private :
        TTypeWizard  FTypeExpert;
        AnsiString   FCheminprojet;
        AnsiString   FNewFicheClass;
        AnsiString   FOTAWizardPage;
        AnsiString   FIOTAWizardComent;
        AnsiString   FIOTAWizardAuthor;
        AnsiString   FIOTAWizardMenuText;
        AnsiString   FIOTAWizardIdString;
        AnsiString   FIOTAWizardNom;
        AnsiString   FClasseWizardName;
        Graphics::TIcon* FIcon;
        AnsiString   FstrFicherIcone;
        AnsiString   FNomProjet;
        bool         FIsDll;
        _di_IOTAProjectGroup  __fastcall CreateProjectGroup();
        void __fastcall CreateAddInWizard();
        void __fastcall CreateHelpWizard();
        void __fastcall CreateProjectWizard();
        void __fastcall CreateFormWizard();
        AnsiString __fastcall FillTemplateExpert(const AnsiString tpl);        
public :
        __fastcall TInfoExpertCollector();
        __fastcall ~TInfoExpertCollector();
        void __fastcall MakeExpertCode();

        __property TTypeWizard  TypeExpert         = {read = FTypeExpert , write = FTypeExpert};
        __property AnsiString   Cheminprojet       = {read = FCheminprojet , write = FCheminprojet};
        __property AnsiString   NewFicheClass      = {read = FNewFicheClass , write = FNewFicheClass};
        __property AnsiString   OTAWizardPage      = {read = FOTAWizardPage , write = FOTAWizardPage};
        __property AnsiString   IOTAWizardComent   = {read = FIOTAWizardComent , write = FIOTAWizardComent};
        __property AnsiString   IOTAWizardAuthor   = {read = FIOTAWizardAuthor , write = FIOTAWizardAuthor};
        __property AnsiString   IOTAWizardMenuText = {read = FIOTAWizardMenuText , write = FIOTAWizardMenuText};
        __property AnsiString   IOTAWizardIdString = {read = FIOTAWizardIdString , write = FIOTAWizardIdString};
        __property AnsiString   IOTAWizardNom      = {read = FIOTAWizardNom , write = FIOTAWizardNom};
        __property AnsiString   ClasseWizardName   = {read = FClasseWizardName , write = FClasseWizardName};
        __property Graphics::TIcon*  Icon          = {read = FIcon , write = FIcon};
        __property AnsiString   strFicherIcone   = {read = FstrFicherIcone , write = FstrFicherIcone};
        __property AnsiString   NomProjet        = {read = FNomProjet , write = FNomProjet};
        __property bool         IsDll = {read = FIsDll , write = FIsDll};
};

/*

*/
#endif
