//---------------------------------------------------------------------------

#ifndef IntfMainH
#define IntfMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

#include "IntfUtils.h"
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <ImgList.hpp>

class TfrmExpert : public TForm
{
__published:	// Composants grs par l'EDI
        TPageControl *pcEtapeExpert;
        TTabSheet *tsTypeWizard;
        TTabSheet *tsWizardClass;
        TTabSheet *tsWizardRecap;
        TPanel *Panel1;
        TSpeedButton *spbtnAnnuler;
        TSpeedButton *spbtnSuivant;
        TSpeedButton *spbtnTerminer;
        TSpeedButton *spbtnPrecedent;
        TGroupBox *GroupBox1;
        TPanel *pnlEnvironnement;
        TGroupBox *GroupBox2;
        TRadioButton *rbExpertPackage;
        TRadioButton *rbExpertDll;
        TGroupBox *GroupBox3;
        TRadioButton *rbtExpertmenu;
        TRadioButton *rbtExpertfiche;
        TRadioButton *rbtExpertmenuaide;
        TRadioButton *rbtExpertprojet;
        TGroupBox *GroupBox4;
        TEdit *edtNomProjet;
        TLabel *Label1;
        TEdit *edtCheminprojet;
        TLabel *Label3;
        TSpeedButton *SpeedButton1;
        TImage *Image1;
        TMemo *mmSummary;
        TOpenPictureDialog *OpdIconeRepository;
        TTabSheet *tsExpertRepository;
        TGroupBox *grpbInfoRepository;
        TLabel *lblOTAWizardIcone;
        TLabel *lblOTAWizardPage;
        TEdit *edtOTAWizardPage;
        TEdit *edtIOTAWizardComent;
        TLabel *lblOTAWizardComent;
        TLabel *lblOTAWizardAuthor;
        TEdit *edtIOTAWizardAuthor;
        TPanel *Panel2;
        TImage *imglOTAWizardIcone;
        TGroupBox *grpbInfoGeneriqueExpert;
        TEdit *edtIOTAWizardMenuText;
        TLabel *lblIOTAWizardMenuText;
        TLabel *lblIOTAWizardIdString;
        TEdit *edtIOTAWizardIdString;
        TLabel *lblFormeIdConseillee;
        TEdit *edtIOTAWizardNom;
        TLabel *lblIOTAWizardNom;
        TLabel *lblClasseWizard;
        TEdit *edtClasseWizardName;
        TImageList *ImageList1;
        TListView *lvError;
        TBitBtn *btnlOTAWizardIcone;
        TLabel *lblIcoFile;
        TGroupBox *grpbExpertFiche;
        TLabel *Label4;
        TRadioButton *rbCreerPascal;
        TRadioButton *rbCreerCpp;
        TEdit *edtNewFicheClass;
        TCheckBox *cbImplementerConstructeur;
        void __fastcall spbtnAnnulerClick(TObject *Sender);
        void __fastcall spbtnSuivantClick(TObject *Sender);
        void __fastcall spbtnPrecedentClick(TObject *Sender);
        void __fastcall spbtnTerminerClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall rbtExpertmenuClick(TObject *Sender);
        void __fastcall rbtExpertficheClick(TObject *Sender);
        void __fastcall rbtExpertmenuaideClick(TObject *Sender);
        void __fastcall rbtExpertprojetClick(TObject *Sender);
        void __fastcall edtClasseWizardNameExit(TObject *Sender);
        void __fastcall SpeedButton1Click(TObject *Sender);
        void __fastcall edtNomProjetChange(TObject *Sender);
        void __fastcall rbExpertPackageClick(TObject *Sender);
        void __fastcall rbExpertDllClick(TObject *Sender);
        void __fastcall edtNomProjetKeyPress(TObject *Sender, char &Key);
        void __fastcall btnlOTAWizardIconeClick(TObject *Sender);
        void __fastcall lvErrorCustomDrawItem(TCustomListView *Sender,
          TListItem *Item, TCustomDrawState State, bool &DefaultDraw);
        void __fastcall lvErrorDeletion(TObject *Sender, TListItem *Item);
        void __fastcall lvErrorDblClick(TObject *Sender);
private:
        TTypeWizard FTypeWizard;
        AnsiString ClassWizardName;
        AnsiString ProjectDirectory;  
        void __fastcall PagePrecedente();
        void __fastcall InitPage(int pageIndex);
        void __fastcall InitPageChoixExpert();	// Dclarations utilisateur
        void __fastcall GererBouton();
        void __fastcall PageSuivante();
        void __fastcall InitPageClasseExpert();
        bool __fastcall CheckPageClasseExpert();
        bool __fastcall CheckPageRepository();
        bool __fastcall CheckPage(int pageIndex);
        void __fastcall Summary();
        void __fastcall InitPageRepository();
        bool __fastcall CheckPageChoixExpert();
public:		// Dclarations utilisateur
        __fastcall TfrmExpert(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmExpert *frmExpert;
//---------------------------------------------------------------------------
#endif







