
//---------------------------------------------------------------------------

#ifndef OTAUtilsH
#define OTAUtilsH

#include <ToolsApi.hpp>
namespace GeoUtils
{
const AnsiString _DELPHIIDENTIFIER = "Delphi";
const AnsiString _CBUILDERIDENTIFIER = "C++Builder";

  void __fastcall CloseAll();
  void __fastcall EditOption();
  void __fastcall SetOption(AnsiString AnOption, const Variant &Value );
  void __fastcall SetOption(_di_IOTAProject ActiveProject,AnsiString AnOption, const Variant &Value );

  _di_IOTAActionServices __fastcall GetActionServices();
  _di_IOTADebuggerServices __fastcall GetDebuggerServices();
  _di_IOTAMessageServices __fastcall GetMessageServices();
  _di_IOTAModuleServices __fastcall GetModuleServices();
  _di_IOTAPackageServices __fastcall GetPackageServices();
  _di_INTAServices __fastcall GetNTAServices();
  _di_IOTAServices __fastcall GetOTAServices();
  _di_IOTAWizardServices __fastcall GetWizardServices();
  _di_IOTAModule __fastcall GetCurrentModule();
  int __fastcall GetModuleCount(void);
  _di_IOTAModule __fastcall GetModule(const int Index);
  AnsiString __fastcall GetBaseRegistryKey();

  AnsiString __fastcall GetProductIdentifier();
  AnsiString __fastcall GetProductProjectExtension(bool isDll);

  _di_IOTAEnvironmentOptions __fastcall GetEnvironmentOptions();
  int __fastcall AddNotifier(const _di_IOTAIDENotifier Notifier)/* overload */
          ;
  void __fastcall RemoveIDENotifier(const int Index);
  TMainMenu* __fastcall GetMainMenu(void);
  TToolBar* __fastcall GetToolBar(const AnsiString ToolBarName);
  TCustomImageList* __fastcall GetImageList(void);
  TCustomActionList* __fastcall GetActionList(void);
  int __fastcall AddMasked(Graphics::TBitmap* Image, Graphics::TColor MaskColor);
  AnsiString __fastcall GetFileName();
  AnsiString __fastcall GetFileSystem();
  _di_IOTAProject __fastcall GetOwner(const int Index);
  int __fastcall GetOwnerCount(void);
  void __fastcall SetFileName(const AnsiString FileName);
  void __fastcall SetFileSystem(const AnsiString FileSystem);
  _di_IOTAProjectGroup __fastcall GetProjectGroup();
  _di_IOTAProject __fastcall GetActiveProject();
  int __fastcall GetProjectCount(void);
  _di_IOTAProject __fastcall GetProject(const int Index);
  void __fastcall SetActiveProject(const _di_IOTAProject Project);
  void __fastcall AddNewProject(void);
  void __fastcall AddExistingProject(void);
  void __fastcall RemoveProject(const _di_IOTAProject Project);
  int __fastcall GetProjectModuleCount(void);
  _di_IOTAModuleInfo __fastcall GetModuleInfo(const int Index);
  _di_IOTAProjectOptions __fastcall GetProjectOptions();
  _di_IOTAProjectBuilder __fastcall GetProjectBuilder();
  bool __fastcall GetShouldBuild(void);
  bool __fastcall BuildProject(TOTACompileMode Mode, bool Wait, bool ClearMessages);
  int __fastcall GetModuleFileCount(void);
  _di_IOTAEditor __fastcall GetModuleFileEditor(const int Index);
  bool __fastcall Close(void);
  bool __fastcall Save(bool ChangeName, bool ForceSave);
  int __fastcall AddNotifier(const _di_IOTAModuleNotifier Notifier);
  void __fastcall RemoveModuleNotifier(const int Index);
  _di_IOTAFormEditor __fastcall GetFormEditor();
  AnsiString __fastcall GetFormFileName();
  bool __fastcall GetFormModified(void);
  _di_IOTAModule __fastcall GetFormModule();
  _di_IOTAComponent __fastcall GetRootComponent();
  _di_IOTAComponent __fastcall FindComponent(const AnsiString Name);
  _di_INTAFormEditor __fastcall GetNTAFormEditor();
  _di_IFormDesigner __fastcall GetFormDesigner();
  void __fastcall GetNTAFormResource(Classes::TStream* Stream);
  TComponent* __fastcall GetTComponent(const _di_IOTAComponent OTAComponent);
  _di_IUnknown __fastcall FindModuleInterface(const GUID &AInterface);
  _di_IOTAModule CreateSimpleModule(_di_IOTACreator ModCreator);
  void __fastcall CreateNewUnit(const AnsiString prefix,
                                AnsiString& UnitIdent,
                                AnsiString& ClassName,
                                AnsiString& FileName);

}

namespace GeoSystem
{
        AnsiString __fastcall BrowseForFolder(HWND AHandleWin);
        void __fastcall CreateRessourceScript(AnsiString AFileName,AnsiString IdName ,AnsiString AIcoFile);
        void __fastcall TextToFile(AnsiString AFileName,AnsiString Text);
        AnsiString __fastcall GetLastPath();
        AnsiString __fastcall FillTemplateExpert(const AnsiString tpl);
}
#endif
