#include <vcl.h>
#pragma hdrstop
#include "WizardMain.h"
#include "IntfMain.h"
#include "OTAUtils.h"
#include "IntfCustForm.h"
#pragma package(smart_init)

/**************************************************************************************/
/*                                  IOTAWizard                                        */
/**************************************************************************************/
__fastcall TWizardGenerator::TWizardGenerator()
{
   d_refcount = 0;
   FProduit = GeoUtils::GetProductIdentifier();

}
/**************************************************************************************/
__fastcall TWizardGenerator::~TWizardGenerator()
{

}
/**************************************************************************************/
AnsiString __fastcall TWizardGenerator::GetIDString()
{
        //A FAIRE : Ajoutez votre code ici

        return "BORLANDCONF2001.EXPERTJEANPHIJPP";
}
/**************************************************************************************/
AnsiString __fastcall TWizardGenerator::GetName()
{
        //A FAIRE : Ajoutez votre code ici
        return "EXPERT\n" + FProduit;
}
/**************************************************************************************/
TWizardState __fastcall TWizardGenerator::GetState()
{
        //A FAIRE : Ajoutez votre code ici
        return TWizardState()<<wsEnabled;
}
/**************************************************************************************/
AnsiString __fastcall TWizardGenerator::GetAuthor()
{
        //A FAIRE : Ajoutez votre code ici
        return " Jeanphi BEAULLIT et Jean-Pierre PLANAS";
}
/**************************************************************************************/
AnsiString __fastcall TWizardGenerator::GetComment()
{
        //A FAIRE : Ajoutez votre code ici
        return "No comment";
}
/**************************************************************************************/
AnsiString __fastcall TWizardGenerator::GetPage()
{
        //A FAIRE : Ajoutez votre code ici
        return "Open Tool";
}
/**************************************************************************************/
HICON __fastcall TWizardGenerator::GetGlyph()
{
        //A FAIRE : Ajoutez votre code ici
        return LoadIcon(HInstance,"GENEXPERT");
}
/**************************************************************************************/
void __fastcall TWizardGenerator::Execute()
{
        //A FAIRE : Ajoutez votre code ici
        TfrmExpert* fm = new TfrmExpert(NULL);
        if(fm->ShowModal() != mrNone)
          delete fm;
}
/**************************************************************************************/
HRESULT STDMETHODCALLTYPE TWizardGenerator::QueryInterface(
        REFIID riid,
        void __RPC_FAR *__RPC_FAR *ppvObject)
{
  *ppvObject = NULL;
  if (IsEqualIID(riid, __uuidof(IUnknown)))
    *ppvObject = static_cast<IUnknown *>(this);
  else if (IsEqualIID(riid, __uuidof(IOTANotifier)))
    *ppvObject = static_cast<IOTANotifier *>(this);
  else if (IsEqualIID(riid, __uuidof(IOTAWizard)))
    *ppvObject = static_cast<IOTAWizard *>(this);
  else if (IsEqualIID(riid, __uuidof(IOTARepositoryWizard)))
    *ppvObject = static_cast<IOTARepositoryWizard *>(this);
 else if (IsEqualIID(riid, __uuidof(IOTAProjectWizard)))
    *ppvObject = static_cast<IOTAProjectWizard *>(this);
  if (*ppvObject != NULL)
  {
    reinterpret_cast<IUnknown *>(*ppvObject)->AddRef();
    return S_OK;
  }
  else
    return E_NOINTERFACE;
}
/**************************************************************************************/
ULONG STDMETHODCALLTYPE TWizardGenerator::AddRef(void)
{
  return InterlockedIncrement(&d_refcount);
}
/**************************************************************************************/
ULONG STDMETHODCALLTYPE TWizardGenerator::Release(void)
{
   long result = InterlockedDecrement(&d_refcount);
   if (d_refcount == 0)
      delete this;
   return result;
}
/**************************************************************************************/
void __fastcall TWizardGenerator::AfterSave(){}
/**************************************************************************************/
void __fastcall TWizardGenerator::BeforeSave(){}
/**************************************************************************************/
void __fastcall TWizardGenerator::Destroyed(){}
/**************************************************************************************/
void __fastcall TWizardGenerator::Modified(){}
/**************************************************************************************/



/***********************************************************************************************
/******************************************************************************************
/**************************************************************************************
/**************************************************************************************/
/*                                  IOTAWizard                                        */
/**************************************************************************************/
__fastcall TWizardFormGenerator::TWizardFormGenerator()
{
   d_refcount = 0;
   FProduit = GeoUtils::GetProductIdentifier();

}
/**************************************************************************************/
__fastcall TWizardFormGenerator::~TWizardFormGenerator()
{

}
/**************************************************************************************/
AnsiString __fastcall TWizardFormGenerator::GetIDString()
{
        //A FAIRE : Ajoutez votre code ici

        return "JPPJEANPHI.EXPERTCUSTOMMODULE";
}
/**************************************************************************************/
AnsiString __fastcall TWizardFormGenerator::GetName()
{
        //A FAIRE : Ajoutez votre code ici
        return "Crateur de fiche perso";
}
/**************************************************************************************/
TWizardState __fastcall TWizardFormGenerator::GetState()
{
        //A FAIRE : Ajoutez votre code ici
        return TWizardState()<<wsEnabled;
}
/**************************************************************************************/
AnsiString __fastcall TWizardFormGenerator::GetAuthor()
{
        //A FAIRE : Ajoutez votre code ici
        return " Jeanphi BEAULLIT et Jean-Pierre PLANAS";
}
/**************************************************************************************/
AnsiString __fastcall TWizardFormGenerator::GetComment()
{
        //A FAIRE : Ajoutez votre code ici
        return "No comment";
}
/**************************************************************************************/
AnsiString __fastcall TWizardFormGenerator::GetPage()
{
        //A FAIRE : Ajoutez votre code ici
        return "Open Tool";
}
/**************************************************************************************/
HICON __fastcall TWizardFormGenerator::GetGlyph()
{
        //A FAIRE : Ajoutez votre code ici
        return LoadIcon(HInstance,"CUSTOMMODULE");
}
/**************************************************************************************/
void __fastcall TWizardFormGenerator::Execute()
{
        //A FAIRE : Ajoutez votre code ici
        TfrmCustomModule* fm = new TfrmCustomModule(NULL);
        if(fm->ShowModal() != mrNone)
          delete fm;
}
/**************************************************************************************/
HRESULT STDMETHODCALLTYPE TWizardFormGenerator::QueryInterface(
        REFIID riid,
        void __RPC_FAR *__RPC_FAR *ppvObject)
{
  *ppvObject = NULL;
  if (IsEqualIID(riid, __uuidof(IUnknown)))
    *ppvObject = static_cast<IUnknown *>(this);
  else if (IsEqualIID(riid, __uuidof(IOTANotifier)))
    *ppvObject = static_cast<IOTANotifier *>(this);
  else if (IsEqualIID(riid, __uuidof(IOTAWizard)))
    *ppvObject = static_cast<IOTAWizard *>(this);
  else if (IsEqualIID(riid, __uuidof(IOTARepositoryWizard)))
    *ppvObject = static_cast<IOTARepositoryWizard *>(this);
 else if (IsEqualIID(riid, __uuidof(IOTAProjectWizard)))
    *ppvObject = static_cast<IOTAProjectWizard *>(this);
  if (*ppvObject != NULL)
  {
    reinterpret_cast<IUnknown *>(*ppvObject)->AddRef();
    return S_OK;
  }
  else
    return E_NOINTERFACE;
}
/**************************************************************************************/
ULONG STDMETHODCALLTYPE TWizardFormGenerator::AddRef(void)
{
  return InterlockedIncrement(&d_refcount);
}
/**************************************************************************************/
ULONG STDMETHODCALLTYPE TWizardFormGenerator::Release(void)
{
   long result = InterlockedDecrement(&d_refcount);
   if (d_refcount == 0)
      delete this;
   return result;
}
/**************************************************************************************/
void __fastcall TWizardFormGenerator::AfterSave(){}
/**************************************************************************************/
void __fastcall TWizardFormGenerator::BeforeSave(){}
/**************************************************************************************/
void __fastcall TWizardFormGenerator::Destroyed(){}
/**************************************************************************************/
void __fastcall TWizardFormGenerator::Modified(){}
/**************************************************************************************/

