#ifndef WizardMainH
#define WizardMainH
#include <ToolsApi.hpp> 
//---------------------------------------------------------------------------
/*
  CONFERENCE BORLAND 2001 (8 & 9 Octobre)
  classes utilitaires de cration d'expert

  Jeanphi & JeanPierre 
*/

class TWizardGenerator : public IOTAProjectWizard

{
  long d_refcount;
  AnsiString FProduit;
  public:
   /* TNotifierObject*/
   virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid,
                                                    void __RPC_FAR *__RPC_FAR *ppvObject);
   virtual ULONG STDMETHODCALLTYPE AddRef();
   virtual ULONG STDMETHODCALLTYPE Release();
   virtual void __fastcall AfterSave();
   virtual void __fastcall BeforeSave();
   virtual void __fastcall Destroyed();
   virtual void __fastcall Modified();

    /*IOTAWizard*/
    virtual AnsiString __fastcall GetIDString();
    virtual AnsiString __fastcall GetName();
    virtual TWizardState __fastcall GetState();
    virtual void __fastcall Execute();
    /*IOTARepositoryWizard*/
    virtual AnsiString __fastcall GetAuthor();
    virtual AnsiString __fastcall GetComment();
    virtual AnsiString __fastcall GetPage();
    virtual HICON __fastcall GetGlyph();

    __fastcall TWizardGenerator();
    virtual __fastcall ~TWizardGenerator();
};



//---------------------------------------------------------------------------

class TWizardFormGenerator : public IOTAProjectWizard

{
  long d_refcount;
  AnsiString FProduit;
  public:
   /* TNotifierObject*/
   virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid,
                                                    void __RPC_FAR *__RPC_FAR *ppvObject);
   virtual ULONG STDMETHODCALLTYPE AddRef();
   virtual ULONG STDMETHODCALLTYPE Release();
   virtual void __fastcall AfterSave();
   virtual void __fastcall BeforeSave();
   virtual void __fastcall Destroyed();
   virtual void __fastcall Modified();

    /*IOTAWizard*/
    virtual AnsiString __fastcall GetIDString();
    virtual AnsiString __fastcall GetName();
    virtual TWizardState __fastcall GetState();
    virtual void __fastcall Execute();
    /*IOTARepositoryWizard*/
    virtual AnsiString __fastcall GetAuthor();
    virtual AnsiString __fastcall GetComment();
    virtual AnsiString __fastcall GetPage();
    virtual HICON __fastcall GetGlyph();

    __fastcall TWizardFormGenerator();
    virtual __fastcall ~TWizardFormGenerator();
};


#endif
